
<template>
    <div class="header col-12" :class="[theme, headerClass]">
        <router-link to="/home" v-if="theme === 'dark_theme'" @click.native="scrollToTop" class="header-logo header-logo_desktop" />
        <router-link to="/home" v-if="theme === 'light_theme'" @click.native="scrollToTop" class="header-logo header-logo_desktop" />
        <router-link to="/home" v-if="headerClass === 'menu_active'" @click.native="scrollToTop" class="header-logo header-logo_mobile" />
        <router-link to="/home" v-if="headerClass === 'menu_inactive'" @click.native="scrollToTop" class="header-logo header-logo_mobile" />

        <img src="./../../public/img/close.png"
             class="header-mobile-close_btn"
             alt=""
             @click="changeVisibilityOfMobileMenu"
             v-if="isMobileMenuOpened"
        >
        <img src="./../../public/img/burger.png"
             class="header-mobile-open_btn"
             alt=""
             @click="changeVisibilityOfMobileMenu"
             v-else
        >

        <nav class="header-navigation col col-md-auto">
            <router-link class="header-navigation-item" to="/home" @click.native="scrollToTop" active-class="active_link">
                {{ $t('header.home') }}
            </router-link>
            <router-link class="header-navigation-item" to="/products" active-class="active_link">
                {{ $t('header.products') }}
            </router-link>
            <router-link class="header-navigation-item" to="/partners" active-class="active_link">
                {{ $t('header.partners') }}
            </router-link>
            <router-link class="header-navigation-item" to="/services" active-class="active_link">
                {{ $t('header.services') }}
            </router-link>
            <!-- <a class="header-navigation-item" href="#" target="_blank" active-class="active_link" style="display: inline-block">
                {{ $t('header.personalArea') }}
            </a> -->
            <router-link class="header-navigation-item" to="/about" active-class="active_link">
                {{ $t('header.about') }}
            </router-link>
        </nav>

        <div class="header-language col-2 col-lg-1"
             @click="changeLanguageChooseVisibility"
        >
            <img class="header-language-img" :src="currentLanguageImg" alt="">
            <span class="header-language-name">
                 {{ currentLanguageName }}
             </span>
            <transition name="showLanguageChoose">
                <div class="header-language-choose"
                     v-if="isLanguageChooseVisible"
                >
                    <div class="header-language-choose-item" @click="changeLanguage('en')"
                         v-if="$locale !== 'en'"
                    >
                        <img src="./../../public/img/english.png" alt="">
                        <span>English</span>
                    </div>
                    <div class="header-language-choose-item" @click="changeLanguage('ru')"
                        v-if="$locale !== 'ru'"
                    >
                        <img src="./../../public/img/ru.png" alt="">
                        <span>Русский</span>
                    </div>
                    <div class="header-language-choose-item" @click="changeLanguage('fa')"
                         v-if="$locale !== 'fa'"
                    >
                        <img src="./../../public/img/fa.png" alt="">
                        <span>فارسی</span>
                    </div>
                    <!--<div class="header-language-choose-item" @click="changeLanguage('ar')"-->
                         <!--v-if="$locale !== 'ar'"-->
                    <!--&gt;-->
                        <!--<img src="./../../public/img/ar.png" alt="">-->
                        <!--<span>عربي</span>-->
                    <!--</div>-->
                </div>
            </transition>
        </div>
        <transition name="mobileMenuAnimation">
            <div class="header-mobile row col-12" v-if="isMobileMenuOpened">
                <nav class="header-mobile-navigation col-12 row">
                    <router-link class="header-mobile-navigation-item" to="/home" @click.native="scrollToTop" active-class="active_mobile_link">
                        {{ $t('header.home') }}
                    </router-link>
                    <router-link class="header-mobile-navigation-item" to="/products" active-class="active_mobile_link">
                        {{ $t('header.products') }}
                    </router-link>
                    <router-link class="header-mobile-navigation-item" to="/partners" active-class="active_mobile_link">
                        {{ $t('header.partners') }}
                    </router-link>
                    <router-link class="header-mobile-navigation-item" to="/services" active-class="active_mobile_link">
                        {{ $t('header.services') }}
                    </router-link>
                    <!-- <a class="header-mobile-navigation-item" href="#" target="_blank" active-class="active_mobile_link" style="display: inline-block">
                        {{ $t('header.personalArea') }}
                    </a> -->
                    <router-link class="header-mobile-navigation-item" to="/about" active-class="active_mobile_link">
                        {{ $t('header.about') }}
                    </router-link>
                </nav>
                <div class="header-mobile-language_items">
                    <img src="./../../public/img/mobile_ru.png" alt="" @click="changeLanguage('ru')">
                    <img src="./../../public/img/mobile_english.png" alt="" @click="changeLanguage('en')">
                    <img src="./../../public/img/mobile_fa.png" alt="" @click="changeLanguage('fa')">
                    <!--<img src="./../../public/img/mobile_ar.png" alt="" @click="changeLanguage('ar')">-->
                </div>
            </div>
        </transition>


    </div>
</template>

<script>
    export default {
        mounted() {
            let logos = document.getElementsByClassName('header-logo');
            if (this.$i18n.locale !== 'en')  this.changeLanguage(this.$i18n.locale);
            if (this.$i18n.locale === 'en' || this.$i18n.locale === 'ru') this.doSiteLTR(logos);
            else this.doSiteRTL(logos);
        },
        data: ()=>({
            isLanguageChooseVisible: false,
            currentLanguageName: 'English',
            currentLanguageImg: 'img/english.png',
            isMobileMenuOpened: false,
            headerClass: 'menu_inactive'
        }),
        props: {
            theme: {
                type: String
            }
        },
        methods: {
            changeLanguageChooseVisibility() {
                let body = document.body;
                let oneClickCloseLanguageChoose = ()=>{
                    this.isLanguageChooseVisible = false;
                };

                this.isLanguageChooseVisible = !this.isLanguageChooseVisible;
                if(this.isLanguageChooseVisible) {
                    setTimeout(()=>{
                        body.addEventListener('click', oneClickCloseLanguageChoose, {once: true})
                    }, 10)
                }
            },
            doSiteRTL() {
                document.body.classList.add('rtl');
                document.body.setAttribute('dir', 'rtl');
            },
            doSiteLTR() {
                document.body.classList.remove('rtl');
                document.body.setAttribute('dir', 'ltr');
            },
            changeLanguage(val) {
                this.$i18n.locale = val;
                //let logos = document.getElementsByClassName('header-logo');
                let changeLanguageData = (name, imgSrc, func) => {
                    this.currentLanguageName = name;
                    this.currentLanguageImg = imgSrc;
                    func;
                };
                switch (val) {
                    case 'en':
                        changeLanguageData('English', 'img/english.png', this.doSiteLTR());
                        break;
                    case 'ru':
                        changeLanguageData('Русский', 'img/ru.png', this.doSiteLTR());
                        break;
                    case 'ar':
                        changeLanguageData('فارسی', 'img/ar.png', this.doSiteRTL());
                        break;
                    case 'fa':
                        changeLanguageData('فارسی', 'img/fa.png', this.doSiteRTL());
                        break;
                    default:
                        changeLanguageData('English', 'img/english.png', this.doSiteLTR());
                }
            },
            changeVisibilityOfMobileMenu() {
                if (this.isMobileMenuOpened) this.headerClass = 'menu_inactive';
                else this.headerClass = 'menu_active';
                this.isMobileMenuOpened = !this.isMobileMenuOpened;
            },
            scrollToTop() {
                window.scrollTo({top: 0, behavior: 'smooth'});
            },
        },
        watch: {
            $locale () {
                this.changeLanguage(this.$i18n.locale);
            }
        }
    }
</script>

<style lang="sass" scoped>
    //vue анимации для появления списка с выбором языка, появления меню на мобильной версии
    .showLanguageChoose-enter
        opacity: 0
        transform: translate3d(0,-10px,0)
    .showLanguageChoose-enter-active
        transition: all 0.4s
    .showLanguageChoose-leave-active
        opacity: 0
        transform: translate3d(0,-10px,0)
        transition: all 0.4s


    .mobileMenuAnimation-enter
        transform: translate3d(30px, 0, 0)
        opacity: 0
    .mobileMenuAnimation-enter-active
        transition: all 0.4s
    .mobileMenuAnimation-leave-active
        transform: translate3d(30px, 0, 0)
        opacity: 0
        transition: all 0.4s

    //переменные
    $opensans: "Open Sans", sans-serif
    %item_title
        font-size: 30px
        -webkit-text-stroke: 1px #898a94
        font-weight: bold
        overflow: hidden
        position: relative
        color: transparent
        text-decoration: none
        margin-bottom: 50px

    .header
        display: flex
        padding: 0
        align-items: center
        height: 40px
        justify-content: space-between
        font-size: 12px
        text-transform: uppercase
        transition: all 0.4s
        &-logo, &-logo_mobile
            width: 70px
            height: 23px
            margin-right: 97px
        &-navigation
            padding: 0
            &-item
                font-family: $opensans
                font-weight: 600
                text-decoration: none
                &:hover
                    cursor: pointer
            &-item:not(:last-of-type)
                margin-right: 34px

        &-language
            padding: 0
            display: flex
            justify-content: center
            align-items: center
            position: relative
            &:hover
                cursor: pointer
            &-img
                margin-right: 5px
            &-name
                padding: 0
            &-choose
                position: absolute
                z-index: 100
                margin-top: 10px
                top: 100%
                width: 100%
                right: 0
                border-radius: 2px
                &-item
                    padding: 7px 12px
                    display: flex
                    align-items: center
                    text-transform: none
                    background-color: #1d1e20
                    transition: all 0.3s
                    color: #fff
                    img
                        margin-right: 4px
                    &:hover
                        background-color:  #47474b
                        cursor: pointer

        &-mobile
            position: absolute
            overflow: hidden
            z-index: 100
            height: 580px
            background-color: #2f2f32
            top: 80px
            left: 0
            padding: 100px 0 0 20px
            align-items: flex-end
            &-close_btn, &-open_btn
                display: none
                position: absolute
                padding: 20px
                right: 0
                top: 8px
            &-navigation
                padding: 0
                margin: 0
                &-item
                    width: 100%
                    padding: 0
                    @extend %item_title
                    margin-bottom: 20px
            &-language_items
                margin-bottom: 22px
                img
                    width: 42px
                    padding: 5px
                img:not(:last-of-type)
                    margin-right: 15px

    .fixed_header
        position: fixed
        top: 0
        left: 0
        padding: 20px 30px !important
        height: 80px !important
        z-index: 100
        @media screen and (max-width: 769px)
            padding: 20px !important

    .dark_theme
        color: #fff
        background: #2f2f32
        .header-logo
            background-image: url("./../../public/img/logo.png")
        .header-navigation-item
            color: #fff
            &:visited
                color: inherit !important
            &:hover
                color: #66676e !important
        .active_link
            color: #66676e!important
        .active_mobile_link
            -webkit-text-stroke: 1px #66676e!important

    .dark_theme.menu_inactive
        .header-logo_mobile
            background-image: url("./../../public/img/logo-dark.png")

    .light_theme, .light_theme__wb
        color: #000
        background: #ffffff
        .header-logo
            background-image: url("./../../public/img/logo-dark.png")
        .header-navigation-item
            color: #000
            &:visited
                color: inherit !important
            &:hover
                color: #b5b5b7!important
        .active_link
            color: #b5b5b7!important
        .active_mobile_link
            -webkit-text-stroke: 1px #66676e!important

    .light_theme__wb
        background: #f1f1f1

    .light_theme.menu_active
        .header-logo_mobile
            background-image: url("./../../public/img/logo.png")

    @media screen and (min-width: 992px) and (max-width: 1280px)
        .header-language
            min-width: 102px
    @media screen and (max-width: 992px)
        .header-navigation-item
            margin-right: 14px
    @media screen and (max-width: 769px)
        .header
            padding: 20px 0
            height: 80px
            &-logo
                margin-right: 0
            &-navigation
                font-size: 12px
                text-align: right
            &-language
                max-width: 90px
    @media screen and (max-width: 991px)
        .header
            padding-left: 20px
            &-mobile
                &-open_btn, &-close_btn
                    display: inline-block
            &-navigation, &-language
                display: none
            &-logo_desktop
                display: none
            &-logo_mobile
                display: inline
        .menu_inactive
            background-color: #fff
        .menu_active
            background-color: #2f2f32
    @media screen and (min-width: 992px)
        .header
            padding-left: 0
            &-mobile
                display: none
                &-open_btn, &-close_btn
                    display: none
            &-navigation
                display: inline
            &-language
                display: flex
            &-logo_desktop
                display: inline
            &-logo_mobile
                display: none
</style>
